/*

Sample userspace kHTTPd logging-daemon


Note:
	This logging-daemon is only intended to serve as an example on how to
	communicate with the kHTTPd logging system. This daemon is by no means
	intended for real usage and is not secure enough for usage on systems
	with "hostile" users. This might change in the future though.

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>

#include "khttpd_log.h"


int SocketFD;

int AcceptSocket()
{
	struct sockaddr_un  name;
	int	sock;
	size_t	size;
	
	remove("/tmp/.khttpdlog");
	
	sock = socket(PF_UNIX,SOCK_STREAM,0);
	
	name.sun_family = AF_FILE;
	
	strcpy(name.sun_path,"/tmp/.khttpdlog");
	
	size = (offsetof(struct sockaddr_un,sun_path) + strlen(name.sun_path)+1);
	
	if (bind(sock,(struct sockaddr *)&name,size) < 0)
	{
		fprintf(stderr,"Error binding \n");
		exit(0);
	}
	
	listen(sock,2);
	
	
	
	return accept(sock,NULL,NULL);
}

int main()
{
	int Socket;
	int iter=0;
	int len;
	struct tm *TM;
	FILE *file;
	char *Time;
	
	struct khttpd_loginfo Req;
	
	printf("Opening socket \n");
	Socket = AcceptSocket();
	
	printf("Opening Logfile \n");
	file = fopen("/var/log/khttpd.log","w");
	
	while (1==1)
	{
		len = recv(Socket,&Req,sizeof(Req),0);
		
		if (len<=0) break;
      		
		TM = gmtime(&Req.Datestamp);
		Time = asctime(TM);
		fprintf(file,"%08x:\t%s\t%i\t%i\%s \n",Req.RemoteHost,Time,Req.Status,Req.Filesize,Req.Filename);
		
		
/*		printf("Filename = %s \n",Req.Filename);
		printf("Time = %s \n",Time);
*/		
		
		
		iter++;
/*		if (iter&15)
			fflush(file);*/
	}
	fclose(file);
	return 0;
}